/******************************************************************************/
/*                                                                            */
/*  xxrsrp05a.p           Release Management Supplier Schedules for LBox      */
/*                                                                            */
/*  MC01 05/21/13 MCE     Created                                             */
/*                                                                            */
/******************************************************************************/
/* rsrp05c.p - Release Management Supplier Schedules                    */
/* Copyright 1986-2007 QAD Inc., Carpinteria, CA, USA.                  */
/* All rights reserved worldwide.  This is an unpublished work.         */
/* REVISION: 7.0    LAST MODIFIED: 01/29/92           BY: WUG *F110*    */
/* REVISION: 7.3    LAST MODIFIED: 12/18/92           BY: WUG *G462*    */
/* REVISION: 7.3    LAST MODIFIED: 06/01/93           BY: WUG *GB48*    */
/* REVISION: 7.3    LAST MODIFIED: 06/29/93           BY: WUG *GC84*    */
/* REVISION: 7.4    LAST MODIFIED: 11/01/93           BY: WUG *H204*    */
/* REVISION: 7.4    LAST MODIFIED: 01/11/94           BY: WUG *H275*    */
/* REVISION: 8.6    LAST MODIFIED: 10/09/97           BY: GYK *K0PC*    */
/* REVISION: 9.0    LAST MODIFIED: 12/01/97    BY: *K1QY* Pat McCormick */
/* REVISION: 9.0    LAST MODIFIED: 03/13/99    BY: *M0BD* Alfred Tan    */
/* REVISION: 9.1    LAST MODIFIED: 03/24/00    BY: *N08T* Annasaheb Rahane    */
/* REVISION: 9.1    LAST MODIFIED: 08/12/00    BY: *N0KP* myb                 */
/* Revision: 1.13   BY: Paul Donnelly (SB)   DATE: 06/28/03  ECO: *Q00L*      */
/* Old ECO marker removed, but no ECO header exists *F0PN*                    */
/* Revision: 1.14   BY: Katie Hilbert        DATE: 11/14/03  ECO: *Q04M*  */
/* $Revision: 1.14.3.1 $  BY: Anju Dubey           DATE: 11/14/03  ECO: *Q154*  */
/*-Revision end---------------------------------------------------------------*/
/******************************************************************************/
/* All patch markers and commented out code have been removed from the source */
/* code below. For all future modifications to this file, any code which is   */
/* no longer required should be deleted and no in-line patch markers should   */
/* be added.  The ECO marker should only be included in the Revision History. */
/******************************************************************************/
/*V8:ConvertMode=Report                                                 */

/* SCHEDULE PRINT SUBPROGRAM */

{mfdeclre.i}
{gplabel.i} /* EXTERNAL LABEL INCLUDE */
{wbrp02.i}

define shared variable supplier_from like po_vend.
define shared variable supplier_to   like po_vend.
define shared variable shipto_from   like po_ship.
define shared variable shipto_to     like po_ship.
define shared variable part_from     like pod_part.
define shared variable part_to       like pod_part.
define shared variable po_from       like po_nbr.
define shared variable po_to         like po_nbr.
define shared variable buyer_from    like po_buyer.
define shared variable buyer_to      like po_buyer.
define shared variable schtype       like sch_type initial 4 no-undo.
define shared variable print_zero    like mfc_logical.

define variable fax_nbr as character format "x(17)" no-undo.
/*MC01*/define variable vFirstVend    as logical initial true           no-undo.
/*MC01*/define variable vVend         as character                      no-undo.
/*MC01*/define variable vEmailTo      as character                      no-undo.
/*MC01*/define variable vEmailAdmin   as character                      no-undo.
/*MC01*/define variable vEmailCC      as character                      no-undo.
/*MC01*/define variable vEmailSubj    as character                      no-undo.
/*MC01*/define variable vEmailName    as character                      no-undo.
/*MC01*/define variable vEmailBody    as character                      no-undo.
/*MC01*/define variable l_textfile as character no-undo.
/*MC01*/define variable path           like prd_path no-undo.
/*MC01*/define variable scrollonly     like prd_scroll_only no-undo.
/*MC01*/define variable spooler        like prd_spooler no-undo.
/*MC01*/define variable printype       as character no-undo.
/*MC01*/define variable dev            as character no-undo.
/*MC01*/define shared variable printype1          as character.
/*MC01*/define shared variable path1              like prd_path.
/*MC01*/define shared variable spooler1           like prd_spooler.
/*MC01*/define shared variable scrollonly1        like prd_scroll_only.
/*MC01*/define shared variable dev1               like prd_dev.

/*MC01*/assign  spooler = spooler1
/*MC01*/        printype = printype1
/*MC01*/        path = path1
/*MC01*/        scrollonly = scrollonly1
/*MC01*/        dev = dev1.

/*MC01*/find first prd_det no-lock  where prd_dev = dev no-error.

/*MC01*//*SSched Admin Email*/
/*MC01*/for_code_mstr:
/*MC01*/for first code_mstr no-lock
/*MC01*/  where code_domain = global_domain
/*MC01*/    and code_fldname= "SSchedEmail"
/*MC01*/    and code_value  = "ToAdministrator":
/*MC01*/  vEmailAdmin = code_cmmt.
/*MC01*/end.  /*for_code_mstr*/

form with frame phead1 width 132.

mainloop:
for each po_mstr no-lock
   where po_domain = global_domain
   and ( po_nbr >= po_from and po_nbr <= po_to
   and   po_vend >= supplier_from and po_vend <= supplier_to
   and   po_buyer >= buyer_from and po_buyer <= buyer_to
   and  (po_sch_mthd = "" or po_sch_mthd = "p" or po_sch_mthd = "b"
         or substring(po_sch_mthd,1,1) = "y") )
   use-index po_nbr,
   each pod_det no-lock
      where pod_domain = global_domain
      and   pod_nbr = po_nbr
      and   pod_sched
      and   pod_part >= part_from and pod_part <= part_to
      and   pod_site >= shipto_from and pod_site <= shipto_to
   use-index pod_nbrln,
   each pt_mstr no-lock
      where pt_domain = global_domain
      and   pt_part = pod_part
/*MC01*/  , first vd_mstr no-lock
/*MC01*/      where vd_domain = global_domain
/*MC01*/        and vd_addr = po_vend
/*MC01*/        and vd__chr04 <> ""
/*MC01*/break by pod_nbr by pod_part by po_vend:

      for each sch_mstr no-lock
         where sch_domain = global_domain
         and   sch_type = schtype
         and   sch_nbr = pod_nbr
         and   sch_line = pod_line
         and   sch_rlse_id = pod_curr_rlse_id[1] :

/*MC01*/ {xxrsrp05.i}

      end. /*FOR EACH sch_mstr*/
end.
{wbrp04.i}
